###* entity ###

class Entity

  constructor: (@id,@xPos,@yPos,@maxspeed,@width,@height) ->
    @dx = 0                     # velocity
    @dy = 0
    @ddx = 0                    # acceleration
    @ddy = 0

    @comps = {}
    @_roundXandY()

  _addComponent: (name,component) ->
    @comps[name] = component
 
  _roundXandY: ->
    @x = Math.round @xPos
    @y = Math.round @yPos
    if @xPos > 0
      @xc = Math.min Math.round @xPos , WIDTH
    else
      @xc = 0
    if @yPos > 0
      @yc = Math.min Math.round @yPos, HEIGHT
    else
      @yc = 0

  update: (delta) ->
    @dx = @dx + @ddx % @maxspeed
    @dy = @dy + @ddy % @maxspeed

    @xPos = (@xPos + @dx)
    @yPos = (@yPos + @dy)

    @_roundXandY()

  intersects: (entity) ->
    if @yPos+@height < entity.yPos or @yPos > entity.yPos + entity.height or  @xPos+@width < entity.xPos or @xPos > entity.xPos+entity.width
      return false
    else
      return true
