###* textComponent ###

# This class is made for text effects and various writeouts. 
# Only one instance per context/canvas is needed for writing text to it.
class TextComponent

  constructor: (@cxt, font) ->
    unless font?
      font = "15px Courier"
    @cxt.font = font
    @txts = []

  # String font - must have format "[size]px face" - ex. "15px Comic Sans MS"
  setFont: (font) ->
    @cxt.font = font
    @letterWidth = font.split('px ')[0]

  typeWrite: (string, xpos, ypos) ->
    a =
      txt:string
      x:xpos
      y:ypos
      letterCount:0
      delay:100
      fadeTime:1500
      color:
        r:255
        g:255
        b:255
      update: ->
        if @letterCount++ is @txt.length
          @delay--
      render: (cxt) ->
        return

    @txts.push a

  update: (delta) ->
    for t in @txts
      t.update()

  render: ->

    #clear
    @cxt.clearRect 0, 0, WIDTH,HEIGHT

    #draw
    @cxt.fillStyle = "rgb(#{@i},#{@i},#{@i})"
    for t in @txts
      t.render(@cxt)

    return