###* game ###

###* Class which holds the critical components of the game.###
class Game

  constructor: ->

    # Sprites
    @sprites = {}

    initSprites = (range,path,suffix) ->

      obj = []
      for i in range
        img = new Image
        img.src = path + "#{i}" + suffix
        obj.push img
      obj

    @sprites.chopper = initSprites [2..7], "images/copter/copter",".png"
    @sprites.clouds = initSprites [1..4], "images/clouds/cloud",".png"
    @sprites.smokepuffs = initSprites [1..5], "images/smokepuffs/smokepuff",".png"

    # Canvases
    initCanvas = (id) ->

      canvas = ($ id )[0]
      canvas.height = HEIGHT
      canvas.width = WIDTH
      cxt = canvas.getContext '2d'
      [canvas,cxt]

    [bg,bgCxt] = initCanvas '#la0'
    [l1,l1Cxt] = initCanvas '#la1'
    [l2,l2Cxt] = initCanvas '#la2'
    [l3,l3Cxt] = initCanvas '#la3'

    @cxt = [bgCxt, l1Cxt, l2Cxt, l3Cxt]
    @can = [bg, l1, l2, l3]

    # States, remember that order sort of matters if you do stuff in constructors... :O
    @states = {
      'menu':new MenuState(@cxt,@sprites),
      'intro':new IntroState(@cxt,@sprites),
      'gameplay':new GameplayState(@cxt,@sprites)
    }

    for k,v of @states
      v.init()

    @currentState = @states['intro']


  update: (delta) ->
    @currentState.update()

  draw: ->
    @currentState.render()

  switchState: (stateName) ->
    @currentState = @states[stateName]
    

DIE = ->
  alert "YOU DIED!"
