###* gameplayState ###

class GameplayState extends State

  constructor: (cxt,sprites) ->
    super cxt,sprites
    @cxt[1].fillStyle = '#44c'
    @cxt[1].fillRect 0,0,WIDTH,HEIGHT

    # Entities
    @chopper = new Chopper 'player_one', @sprites.chopper
    @entities = []

    for c,i in @sprites.clouds
      @entities.push new Cloud i,c

  update: (delta) ->
    @chopper.update(delta)

    delay = 28
    if keys['Up']
      @chopper.ddy = -0.01
      delay -= 23
    else if keys['Down']
      @chopper.ddy = 0.01
      delay += 1000
    else
      @chopper.ddy = 0.005

    if keys['Left']
      @chopper.ddx = -0.004
      if delay < 28 
        delay -= 4 
      else 
        delay -= 21
    else if keys['Right']
      @chopper.ddx = 0.004
      if delay < 28 
        delay -= 4 
      else 
        delay -= 21
    else
      @chopper.ddx = 0
      
    @chopper.comps.sprites.setDelay delay

    for e in @entities
      e.update()

  render: ->
    # Clear
    @chopper.clear(@cxt[2])
    for e in @entities
      e.clear(@cxt[3])

    # Render
    @chopper.render(@cxt[2])
    for e in @entities      
      e.render(@cxt[3])
    return
